'inteligentny czajnik z przyciskami zblieniowymi
'data: 10.06.2018 r.
'program: Bascom AVR 2.0.7.8
'autor: Piotr wierczek


$regfile = "m8def.dat"

$crystal = 8000000

$hwstack = 32
$swstack = 40
$framesize = 40

'konfiguracja przetwornika  A/D

Config Adc = Single , Prescaler = Auto , Reference = Internal
Start Adc

'zmienne


Dim U_czuj As Word
Dim Tempu As Byte

Dim A As Byte
Dim B As Byte
Dim Temp As Byte


'konfiguracja portw

Config Portb.6 = Output                                     'grzaka
Config Portb.7 = Output                                     'led 40
Config Portd.5 = Output                                     'zapas
Config Portd.6 = Output                                     'led70
Config Portd.7 = Output                                     'led80
Config Portb.0 = Output                                     'led90
Config Portb.1 = Output                                     'buzzer
Config Portc.1 = Input                                      'pomocniczy
Config Portc.0 = Input                                      'pomocniczy1


Config Portc.2 = Input                                      'wyl
Config Portc.3 = Input                                      'mode




'zmiana nazwy i ustawienie stanu portw

Grzanie Alias Portb.6
Led40 Alias Portb.7
Led70 Alias Portd.6
Led80 Alias Portb.0
Led90 Alias Portd.7
Spk Alias Portb.1
Mode Alias Pinc.3
Wyl Alias Pinc.2
Pom Alias Portc.1
Pom1 Alias Portc.0

Grzanie = 0
Spk = 1
Mode = 1
Wyl = 1
Pom = 1
Pom1 = 1
Led40 = 1
Led70 = 1
Led80 = 1
Led90 = 1

Temp = 4


Wait 1

'testowanie po wczeniu zasilania lub resecie

'sprawdzenie ledw

Gosub Cwir

Led40 = 0
Waitms 100
Led40 = 1
Gosub Cwir

Led70 = 0
Waitms 100
Led70 = 1
Gosub Cwir

Led80 = 0
Waitms 100
Led80 = 1
Gosub Cwir

Led90 = 0
Waitms 100
Led90 = 1
Gosub Cwir


Wait 1




'Pocztek programu, ptla gwna

 Do

      U_czuj = Getadc(4)                                    'warto "cyfrowa" temperatury po przetworzeniu


'Obsuga wycznika

If Wyl = 1 Then                                             'przerzutnik T strona 80
 Waitms 40
  If Wyl = 1 And Pom1 = 1 Then
   Toggle Grzanie                                           'Grzanie wacz/wycz
     Gosub Cwir

  Pom1 = 0
 End If
   Else
   Pom1 = 1
 End If

'Sprawdzanie temperatury wody

 If U_czuj > 145 Then
 Led40 = 0
 End If
 If U_czuj < 140 Then
 Led40 = 1
 End If


 If U_czuj > 310 Then
 Led70 = 0
 End If
 If U_czuj < 295 Then
 Led70 = 1
 End If


 If U_czuj > 368 Then
 Led80 = 0
 End If
 If U_czuj < 360 Then
 Led80 = 1
 End If



 If U_czuj > 485 Then
 Led90 = 0
 End If
 If U_czuj < 480 Then
 Led90 = 1
 End If

 'sprawdzanie zadanych warunkw

 If Led40 = 0 And Grzanie = 1 And Temp = 1 Then
 Grzanie = 0                                                'wyczenia grzaki
 Gosub Alarm
 End If

 If Led70 = 0 And Grzanie = 1 And Temp = 2 Then
 Grzanie = 0                                                'wyczenia grzaki
 Gosub Alarm
 End If

 If Led80 = 0 And Grzanie = 1 And Temp = 3 Then
 Grzanie = 0                                                'wyczenia grzaki
 Gosub Alarm
 End If


 If Led90 = 0 And Grzanie = 1 And Temp = 4 Then
 Wait 10                                                    'gotowanie jeszcze przez 10 sekund
 Gosub Alarm
 Grzanie = 0                                                'wyczenia grzaki
 End If

 'gdy np. zabraknie wody alarm cigy i prba wyaczenia

 If U_czuj > 530 Then
 Gosub Alarm
 Grzanie = 0
 End If


 'obsluga przycisku mode

 If Mode = 1 Then                                           'przerzutnik T strona 80
 Waitms 40
  If Mode = 1 And Pom = 1 Then
   Decr Temp                                                'zmie zakres temperatury
   If Temp = 0 Then Temp = 4
     Gosub Cwir
  Pom = 0
 End If
   Else
   Pom = 1
 End If


 'Wybranienie temperatury wyczenia grzaki

 If Temp = 1 Then
 Led40 = 0
 Waitms 50
 Led40 = 1
 Waitms 50
 End If

 If Temp = 2 Then
 Led70 = 0
 Waitms 50
 Led70 = 1
 Waitms 50
 End If

 If Temp = 3 Then
 Led80 = 0
 Waitms 50
 Led80 = 1
 Waitms 50
 End If

 If Temp = 4 Then
 Led90 = 0
 Waitms 50
 Led90 = 1
 Waitms 50
 End If



 Loop                                                       'koniec ptli


 End


'Procedury pomocnicze


Alarm:

For B = 1 To 15                                             'generowanie alarmu 16 x Cwir
Gosub Cwir
Next B
Return

Cwir:                                                       'efekt dwikowy mojego pomysu :-)

For A = 1 To 130
Spk = 0
Waitus 250
Spk = 1
Waitus 250
Next A


For A = 1 To 150
Spk = 0
Waitus 200
Spk = 1
Waitus 200
Next A


For A = 1 To 170
Spk = 0
Waitus 170
Spk = 1
Waitus 170
Next A


For A = 1 To 210
Spk = 0
Waitus 150
Spk = 1
Waitus 150
Next A

Waitms 100

Return

'Program zajmuje 16% pamieci flash